<template>
  <b-container>
    <div class="pageTitle">
      <h1>
        <b-icon-calendar-4 />
        Detalhes da Consulta
      </h1>
      <div class="pageTitle__view">
        <b-button :to="{ name: 'list' }" squared size="sm" variant="primary">
          Voltar
        </b-button>
      </div>
    </div>
    <b-alert :show="loading || alertShow" :variant="alertVariant">
      <b-spinner small variant="secondary" v-if="alertVariant === 'secondary' && loading" />
      {{ alertMessage }}
    </b-alert>
    <b-row v-if="!loading && getAppointmentSelected">
      <b-col xs="12" lg="4" class="mb-4">
        <b-card header="Data da Consulta">
          <b-card-text>{{ appointmentSelected.date }}</b-card-text>
        </b-card>
      </b-col>
      <b-col xs="12" lg="4" class="mb-4">
        <b-card header="Hora da Consulta">
          <b-card-text>{{ appointmentSelected.hour }}</b-card-text>
        </b-card>
      </b-col>
      <b-col xs="12" lg="4" class="mb-4">
        <b-card header="Médico">
          <b-card-text>{{ appointmentSelected.doctor }}</b-card-text>
        </b-card>
      </b-col>
      <b-col xs="12" lg="12" class="mb-4">
        <b-card header="Nome do Paciente">
          <b-card-text>{{ appointmentSelected.pacient }}</b-card-text>
        </b-card>
      </b-col>
      <b-col xs="12" lg="12" class="mb-4">
        <b-card header="Observação">
          <b-card-text>{{ appointmentSelected.observation }}</b-card-text>
        </b-card>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import { mapActions, mapGetters } from "vuex";

export default {
  computed: {
    ...mapGetters('appointment', ['getAppointmentSelected']),

    appointmentSelected() {
      if (!this.getAppointmentSelected) return null

      const dateArray = this.getAppointmentSelected.dataConsulta.split(' ')
      const { medico: { nome }, observacao, paciente } = this.getAppointmentSelected

      return {
        date: dateArray[0],
        hour: dateArray[1],
        doctor: nome,
        observation: observacao,
        pacient: paciente
      }
    }
  },

  methods: {
    ...mapActions('appointment', ['getAppointment']),
    async setupAppointment() {      
      this.loading = true

      const id = this.$route.params.id
      const { message, success } = await this.getAppointment({ id })

      this.loading = false

      if (!success) {
        this.alertVariant = 'danger'
        this.alertMessage = message

        setTimeout(() => {
          this.alertShow = true
        }, 100);
      }
    }
  },

  mounted() {
    this.setupAppointment()
  },

  data() {
    return {
      alertVariant: 'secondary',
      alertMessage: 'Carregando informações da consulta',
      alertShow: false,
      loading: true
    }    
  }
}
</script>

<style>

</style>